unit kds2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Menus, ComCtrls, StdCtrls, TAGraph, TASeries, {TAGraph,} prodelph, about, ext_files;



type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    Chart1LineSeries2: TLineSeries;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckGroup1: TCheckGroup;
    CheckGroup2: TCheckGroup;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    Panel1: TPanel;
    //PlotPanel1: TPlotPanel;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    SaveDialog1: TSaveDialog;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Change(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox4Change(Sender: TObject);
    procedure CheckBox5Change(Sender: TObject);
    procedure CheckGroup1ItemClick(Sender: TObject; Index: integer);
    procedure CheckGroup2ItemClick(Sender: TObject; Index: integer);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MenuItem10Click(Sender: TObject);
    procedure MenuItem11Click(Sender: TObject);
    procedure MenuItem12Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure rys_wykres(model_no:integer);
    procedure rys_wykres_piecewise;
    procedure set_graph;
    procedure CheckBox3Change(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    current_model:integer;
    smooth_graph:Boolean;
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.set_graph;
var i:integer;
begin
   Chart1LineSeries1.Clear;
   Chart1LineSeries2.Clear;

   Chart1.Extent.UseXMin:=True;
   Chart1.Extent.UseYMin:=True;

    for i:=1 to obl.n do
        Chart1LineSeries2.AddXY(obl.x[i], obl.y[i]);

 end;{set_graph}
procedure TForm1.rys_wykres_piecewise;
 var i,k:integer;
     pom,pom1:double;
 begin

 set_graph;

 for k:=1 to obl.lk_mod do
 begin
   if smooth_graph then
    begin

     if k in [7,9,12,14] then
       begin
        pom:=(obl.xmax-obl.tab_zapis[k].param[2])/1000;
        pom1:=obl.tab_zapis[k].param[2];
       end
      else
       begin
        pom:=(obl.xmax-obl.xmin)/1000;
        pom1:=obl.xmin;
       end;

     while pom1<=obl.x[obl.tab_zapis[k].kon] do
      begin
        pom1:=pom1+pom;
        obl.obl_wart_modeli(pom1,k);
        Chart1LineSeries1.AddXY(pom1,obl.tab_zapis[k].wart);
      end;
    end{if smooth_graph then}
   else
   begin
    for i:=obl.tab_zapis[k].pocz to obl.tab_zapis[k].kon do
      begin
      obl.obl_wart_modeli(obl.x[i],k);
      Chart1LineSeries1.AddXY(obl.x[i],obl.tab_zapis[k].wart);
     end;{i}
   end;{if smooth_graph then... else}


   end;{k}

 end;{rys_wykres_piecewise}

procedure TForm1.rys_wykres(model_no:integer);
 var i:integer;
     pom,pom1:double;
 begin

  set_graph;

   if smooth_graph then
    begin
     pom:=(obl.xmax-obl.xmin)/1000;
     pom1:=0;
     while pom1<obl.xmax do
      begin
        pom1:=pom1+pom;
        obl.obl_wart_modeli(pom1,model_no);
        Chart1LineSeries1.AddXY(pom1,obl.tab_zapis[model_no].wart);
      end;
    end{if smooth_graph then}
   else
   begin
    for i:=1 to obl.n do
      begin
      obl.obl_wart_modeli(obl.x[i],model_no);
      Chart1LineSeries1.AddXY(obl.x[i],obl.tab_zapis[model_no].wart);
     end;{i}
   end;{if smooth_graph then... else}


 end;{rys_wykres}
 
procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  Application.Terminate;

end;

procedure TForm1.Button1Click(Sender: TObject);
var lan:String;
begin
  inc(current_model);

  while not obl.tab_models[current_model] do
                                           inc(current_model);
    if (current_model=11) then inc(current_model);

  if current_model>ile_modeli then current_model:=0;

  lan:=obl.get_model_error_description(current_model);

  if obl.work_mode = 0 then
     Panel1.Caption:=CheckGroup1.Items.Strings[current_model]+' '+lan
  else
    Panel1.Caption:='Piecewise regression';
  rys_wykres(current_model);
end;

procedure TForm1.Button2Click(Sender: TObject);
var lan:String;
    wart:double;
begin
  dec(current_model);

  while not obl.tab_models[current_model] do
                                            dec(current_model);

  if (current_model=11) then dec(current_model);

  if current_model<0 then current_model:=ile_modeli;

  lan:=obl.get_model_error_description(current_model);

  if obl.work_mode = 0 then
    Panel1.Caption:=CheckGroup1.Items.Strings[current_model]+' '+lan
    else
    Panel1.Caption:='Piecewise regression';
  rys_wykres(current_model);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
if not OpenDialog1.Execute then exit;
       Memo1.Lines.Clear;
       Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
       Label4.Caption:=ExtractFileName(OpenDialog1.FileName);

end;


procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  smooth_graph:=CheckBox1.Checked;
  Edit2.Enabled:=smooth_graph;
end;

procedure TForm1.CheckBox2Change(Sender: TObject);
begin
   obl.add_sep_models_files:=CheckBox2.Checked;
   if CheckBox2.Checked then
   begin
    Form3.ShowModal;
    if Form3.hit_Cancel then
     begin
          CheckBox2.Checked:=False;
          obl.add_sep_models_files:=False;
     end;{if Form3.hit_Cancel}
   end;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin

end;

procedure TForm1.CheckBox4Change(Sender: TObject);
begin
  obl.use_NLR:=CheckBox4.Checked;
  CheckBox5.Enabled:=CheckBox4.Checked;
  if not obl.use_NLR then
    begin
     CheckBOx5.Checked:=False;
     obl.NLR_start_random:=False;
    end;
end;

procedure TForm1.CheckBox5Change(Sender: TObject);
begin
  obl.NLR_start_random:=CheckBox5.Checked;
end;

procedure TForm1.CheckBox3Change(Sender: TObject);
begin
 obl.licz_bledy_stand:=CheckBox3.Checked;
end;


procedure TForm1.CheckGroup1ItemClick(Sender: TObject; Index: integer);
begin
  obl.tab_models[Index]:=CheckGroup1.Checked[Index];
end;

procedure TForm1.CheckGroup2ItemClick(Sender: TObject; Index: integer);
begin
 obl.tab_set_param[Index]:=CheckGroup2.Checked[Index];
 if obl.tab_set_param[0] then
    begin
      Edit3.Enabled:=True;
      Edit3Change(Sender);
    end{if tab_set_param[0]}
     else
       Edit3.Enabled:=False;

 if obl.tab_set_param[1] then
    begin
      Edit4.Enabled:=True;
      Edit4Change(Sender);
    end{if tab_set_param[1]}
     else
       Edit4.Enabled:=False;

end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  obl.tolerance:=obl.wartosc(Edit1.Text);
  if obl.tolerance=-999 then
   begin
    obl.tolerance:=0.95;
    Edit1.Text:='0.95';
   end;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  obl.lk_test_weibull:=round(obl.wartosc(Edit2.Text));
  if obl.lk_test_weibull=-999 then
   begin
    obl.lk_test_weibull:=1000;
    Edit2.Text:='1000';
   end;

end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
  obl.set_a:=obl.wartosc(Edit3.Text);
  if obl.set_a=-999 then
   begin
    obl.set_a:=0;
    Edit3.Text:='0';
   end;
end;

procedure TForm1.Edit4Change(Sender: TObject);
begin
   obl.set_b:=obl.wartosc(Edit4.Text);
  if obl.set_b=-999 then
   begin
    obl.set_b:=0;
    Edit4.Text:='0';
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin

 smooth_graph:=False;
 
 current_model:=0;
 obl:=oblicz.Create();
 obl.tolerance:=0.95;
 obl.work_mode:=0;
 obl.lag:=0;
 obl.loop_mode:=False;
 obl.err_type:=0;

  for i:=0 to 100 do
   obl.tab_models[i]:=True;
   
   for i:=0 to (CheckGroup1.Items.Count-1) do
            CheckGroup1.Checked[i]:=True;
            
  obl.new_abr:=False;
  obl.licz_bledy_stand:=True;
  obl.lk_test_weibull:=1000;

  obl.set_a:=0;
  obl.set_b:=0;
  
  for i:=0 to 4 do
    obl.tab_set_param[i]:=False;

  obl.short_model_names[0]:='0 order';
  obl.short_model_names[1]:='1 order';
  obl.short_model_names[2]:='2 order';
  obl.short_model_names[3]:='3 order';
  obl.short_model_names[4]:='Korsmeyer-Peppas';
  obl.short_model_names[5]:='aln(x)+b';
  obl.short_model_names[6]:='Weibull';
  obl.short_model_names[7]:='Weibull_lag';
  obl.short_model_names[8]:='Hixson-Crowell';
  obl.short_model_names[9]:='Hixson-Crowell_lag';
  obl.short_model_names[10]:='Higuchi';
  obl.short_model_names[11]:='Baker-Lonsdale';
  obl.short_model_names[12]:='Korsmeyer-Peppas_lag';
  obl.short_model_names[13]:='Michaelis-Menten';
  obl.short_model_names[14]:='Michaelis-Menten_lag';
  obl.short_model_names[15]:='Hill';

  obl.add_sep_models_files:=False;
  obl.add_sep_models_files_orig:=True;
  obl.use_NLR:=False;
  obl.NLR_start_random:=False;
end;

procedure TForm1.MenuItem10Click(Sender: TObject);
begin
  Chart1.CopyToClipboardBitmap;
end;

procedure TForm1.MenuItem11Click(Sender: TObject);
begin
  SaveDialog1.FilterIndex:=2;
  if not SaveDialog1.Execute then exit;
  Chart1.SaveToBitmapFile(SaveDialog1.FileName);
end;

procedure TForm1.MenuItem12Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.MenuItem2Click(Sender: TObject);
begin
 if not OpenDialog1.Execute then exit;
 Label2.Caption:='Loop mode is OFF';
 ListBox1.Clear;
 ListBox1.Enabled:=False;
 obl.loop_mode:=False;
 obl.nazwa_pliku_in:=OpenDialog1.FileName;
 obl.otwieranie_pliku(0);
 set_graph;
 Form1.Caption:='KinetDS ['+ExtractFileName(obl.nazwa_pliku_in)+']';
 Application.ProcessMessages;
end;

procedure TForm1.MenuItem3Click(Sender: TObject);
var i:integer;
begin
  if not OpenDialog1.Execute then exit;
  Label2.Caption:='Loop mode is ON';
  ListBox1.Enabled:=True;
  ListBox1.Clear;
  for i:=0 to (OpenDialog1.Files.Count-1) do
        ListBox1.Items.Add(OpenDialog1.Files.Strings[i]);
  obl.ile_plikow:=ListBox1.Items.Count;
  obl.loop_mode:=True;
end;

procedure TForm1.MenuItem4Click(Sender: TObject);
begin
 SaveDialog1.FilterIndex:=1;
 if not SaveDialog1.Execute then exit;
end;


procedure TForm1.MenuItem7Click(Sender: TObject);
var i,pom_loop:integer;
    lan:String;

begin
 try
   current_model:=-1;
   Panel1.Caption:='Working...';
   Application.ProcessMessages;
   if obl.loop_mode then
    begin
     pom_loop:=obl.ile_plikow;
     lan:=ExtractFilePath(ListBox1.Items.Strings[0])+'report_'+ExtractFileName(ListBox1.Items.Strings[0]);
     AssignFile(obl.plik_raportu,lan);
     Rewrite(obl.plik_raportu);
     obl.first_loop:=True;
    end {if loop mode}
   else pom_loop:=1;

for i:=1 to pom_loop do
 begin

  if obl.loop_mode then
   begin
    obl.nazwa_pliku_in:=ListBox1.Items.Strings[i-1];
    obl.otwieranie_pliku(i);
   end;

     Form1.Caption:='KinetDS 2.0 ['+ExtractFileName(obl.nazwa_pliku_in)+']';

     obl.startuj;

     obl.save_res_to_file;
  end;{i}

  finally
   if obl.loop_mode then CloseFile(obl.plik_raportu);
    {else
     begin }
       lan:=obl.get_model_error_description(obl.wsk_best);

       if obl.work_mode = 0 then
              Panel1.Caption:=CheckGroup1.Items.Strings[obl.wsk_best]+' '+lan
          else
              Panel1.Caption:='Piecewise regression';
       if obl.work_mode = 0 then rys_wykres(obl.wsk_best)
       else rys_wykres_piecewise;

       Memo1.Lines.Clear;
       Memo1.Lines.LoadFromFile(obl.nazwa_pliku_res);
       Label4.Caption:=ExtractFileName(obl.nazwa_pliku_res);
     {end; }
  end;


   {startuj;
  save_res_to_file;}
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  obl.work_mode:=RadioGroup1.ItemIndex;
  case obl.work_mode of
   0:begin
     Button1.Enabled:=True;
     Button2.Enabled:=True;
     Edit1.Enabled:=False;
   end;//0;
   1:begin
     Button1.Enabled:=False;
     Button2.Enabled:=False;
     Edit1.Enabled:=True;
   end;//1;
  end;
end;

procedure TForm1.RadioGroup2Click(Sender: TObject);
begin
  obl.err_type:=RadioGroup2.ItemIndex;
  if obl.err_type=1 then
     obl.new_abr:=True
   else
    obl.new_abr:=False;
end;



initialization
  {$I kds2.lrs}

end.

