
  unit prodelph;

   interface

   uses
   Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Menus, ComCtrls, usimplex,utypes;


   const ile_modeli=15;
   const max_tab=1000000;
   {max number of data points}
   type zapis = record
                a,b,r,r_empirical,wart,wart_lin,st_err_a,st_err_b,percent_st_err_a,percent_st_err_b,
                RMSE,AIC,BIC                                                                        :double;
                rzad,pocz,kon:integer;
                param:array [0..10] of double;
               end;

  type oblicz = class(TObject)
           procedure startuj;
           procedure sumuj(start,koniec,rzad:integer);
           procedure oblicz_abr(var a0,b0,r0:double;j,pocz1,kon1,model:integer);
           procedure oblicz_abr_Higuchi(var a0,b0,r0:double;j,pocz1,kon1:integer);
           procedure oblicz_abr_new(var a0,b0,r0:double;j,pocz1,kon1,model:integer);
           procedure save_sol(var tab: array of zapis;no:integer);
           procedure copy_piecewise_to_original;
           procedure save_params(var tab: array of zapis;a1,b1,lag1:double;no:integer);
           procedure save_res_to_file;
           procedure otwieranie_pliku(ind:integer);
           function wartosc(w:String):double;
           procedure zapisz_param_modeli(model:integer);
           procedure obl_wart_modeli(wartosc1:double;model:integer);
           procedure licz_model_lag(nr:integer);
           procedure oblicz_stand_err_estim(a0,b0:double;pocz1,kon1,model,liczba_param:integer);
           procedure obl_wart_modeli_linear(wartosc1:double;model:integer);
           procedure model_independent;
           procedure get_prediction(nr:integer);
           function is_better_model(nr:integer; var best_value:double):boolean;
           procedure spearate_models_outputs(model_no:integer);
           procedure sort(var tab:array of integer;tab2:array of double;zakres:integer);
           procedure testsimp(indeks_modelu:integer);
           function get_model_error_description(nr:integer):string;

        public
        r_best,r_best_hist,sumaX,sumaY,sumaXY,sumaXX,sumaYY,tolerance,srednia_x,srednia_y,
        xmin,xmax,ymin,ymax,lag,lag_best,a,b,r,set_a,set_b,srednia_x_current,srednia_y_current,reszty_x,
        st_err_a,st_err_b,percent_st_err_a,percent_st_err_b,MDT,dissol_efficiency,RMSE_prediction,
        AIC_prediction,BIC_prediction,separate_model_lower_enum,separate_model_upper_enum,MSE_actual:double;
        tab_zapis,tab_zapis_piecewise:array [0..max_tab] of zapis;
        current_model,work_mode,lk_mod,start,stop,wsk_best,lk_test_weibull,n,
        ile_plikow,liczba_parametrow,lk_prediction,err_type{0-R,1-R_empirical,2-AIC,3-BIC},
        separate_model_enumeration,separate_model_enumeration_orig_data,current_model_NLR                    :integer;
        tab_models:array [0..max_tab] of Boolean;
        tab_set_param:array [0..4] of Boolean;
        x,y,x_current,y_current:array[0..max_tab] of double;
        y_prediction:array of double;
        loop_mode,first_loop,new_abr,licz_bledy_stand,add_sep_models_files,add_sep_models_files_orig,use_NLR,
        NLR_start_random                                                                                     :Boolean;
        nazwa_pliku_res,nazwa_pliku_in,sciezka_out:String;
        plik_raportu:TextFile;
        short_model_names:array [0..(ile_modeli+1)] of String;
    end;
    
    var obl:oblicz;
    
   implementation

function oblicz.get_model_error_description(nr:integer):string;
var etiq,lan:string;
 begin
  etiq:='';
  lan:='';
  case err_type of
     0,1:begin
          str(tab_zapis[nr].r:10:4,lan);
          etiq:='R2 = ';
       end;{0,1}
     2:begin
          str(tab_zapis[nr].AIC:10:4,lan);
          etiq:='AIC = ';

       end;{2}
     3:begin
          str(tab_zapis[nr].BIC:10:4,lan);
          etiq:='BIC = ';
       end;{3}

     4:begin
          str(tab_zapis[nr].RMSE:10:4,lan);
          etiq:='RMSE = ';
       end;{3}

     end;{case}

    get_model_error_description:=etiq+lan;
 end;{get_model_descr}

procedure oblicz.sort(var tab:array of longint;tab2:array of double;zakres:longint);
          {od najmniejszej do najwiêkszej}
               var
                i,k,pom:longint;
                  begin
                     for i:=1 to zakres do
                      tab[i]:=i;

                       for i:=1 to zakres do
                        for k:=i to zakres do
                          if tab2[tab[i]]>tab2[tab[k]] then
                             begin
                              pom:=tab[k];
                              tab[k]:=tab[i];
                              tab[i]:=pom;
                             end;

                  end;{sort}


procedure oblicz.spearate_models_outputs(model_no:integer);
var x_sep_model,y_sep_model:array of double;
    kolejn:array of longint;
    sep_model_step,sep_model_step_orig_data,pom:double;
    lk_step,total_points,i:longint;
    plik_sep_data:TextFile;
    nazwa,directory:String;
begin
     //for GUI
     {separate_model_lower_enum:=0.1;
     separate_model_upper_enum:=50000.1;
     separate_model_enumeration:=1000;
     separate_model_enumeration_orig_data:=round(separate_model_enumeration/10);}

     //regular code
     x_sep_model:=nil;
     y_sep_model:=nil;

     sep_model_step:=(separate_model_upper_enum-separate_model_lower_enum)/separate_model_enumeration;

     sep_model_step_orig_data:=(xmax-xmin)/separate_model_enumeration_orig_data;

     pom:=separate_model_lower_enum-sep_model_step;
     lk_step:=0;

     //pre-defined range
     while pom<=separate_model_upper_enum do
     begin
      inc(lk_step);
      SetLength(x_sep_model,lk_step+1);
      SetLength(y_sep_model,lk_step+1);
      SetLength(kolejn,lk_step+1);
      pom:=pom+sep_model_step;
      x_sep_model[lk_step]:=pom;
      obl_wart_modeli(x_sep_model[lk_step],model_no);
      y_sep_model[lk_step]:=tab_zapis[model_no].wart;
      total_points:=lk_step;
     end;{while pom<=}


    //orig_data
   if add_sep_models_files_orig then
   begin
    pom:=xmin-sep_model_step_orig_data;
     while pom<=xmax do
     begin
      inc(lk_step);
      SetLength(x_sep_model,lk_step+1);
      SetLength(y_sep_model,lk_step+1);
      SetLength(kolejn,lk_step+1);
      pom:=pom+sep_model_step_orig_data;
      x_sep_model[lk_step]:=pom;
      obl_wart_modeli(x_sep_model[lk_step],model_no);
      y_sep_model[lk_step]:=tab_zapis[model_no].wart;
      total_points:=lk_step;
     end;{while pom<=}
   end;{if ad_sep_models_orig}

     try

     directory:=ExtractFilePath(nazwa_pliku_res);
     nazwa:=ExtractFileName(nazwa_pliku_res);
     nazwa:=LeftStr(nazwa,Length(nazwa)-4)+'_';
     nazwa:=directory+nazwa+short_model_names[model_no]+'.txt';

      sort(kolejn,x_sep_model,total_points);

     AssignFile(plik_sep_data,nazwa);
     Rewrite(plik_sep_data);

     for i:=1 to total_points do
      writeln(plik_sep_data,x_sep_model[kolejn[i]],#9,y_sep_model[kolejn[i]]);

     finally
      CloseFile(plik_sep_data);
      x_sep_model:=nil;
      y_sep_model:=nil;
     end;
end;{separate_moels_outputs}

function oblicz.is_better_model(nr:integer; var best_value:double):boolean;
var decision:boolean;
    pom:double;
begin
     decision:=false;
     get_prediction(nr);

     case err_type of
     0,1:begin
               pom:=r;
              if pom>best_value then
                decision:=true;
       end;{0,1}
     2:begin
              pom:=tab_zapis[nr].AIC;
              if pom<best_value then
               decision:=true;
       end;{2}
     3:begin
              pom:=tab_zapis[nr].BIC;
              if pom<best_value then
                decision:=true;
       end;{3}

     4:begin
              pom:=RMSE_prediction;
              if pom<best_value then
                decision:=true;
       end;{3}

     end;{case}

     if decision then best_value:=pom;
     is_better_model:=decision;

end;{is_better_model}

procedure oblicz.get_prediction(nr:integer);
var i,k,model_no,pom_start,lk_param:integer;
    obs,pred,RSS:double;

begin
 //absolute measures of goodness of fit
 try
  lk_param:=2;
  case nr of
       7,9,12,14:lk_param:=3;
  end;

  RSS:=0;
  model_no:=0;
  {first_loop:=True;}
  RMSE_prediction:=0;
  y_prediction:=nil;
  lk_prediction:=0;

  if work_mode=0 then
  begin
  model_no:=nr{wsk_best};
  for i:=1 to obl.n do
      begin
      obs:=y[i];
      inc(lk_prediction);
      obl_wart_modeli(obl.x[i],model_no);
      pred:=tab_zapis[model_no].wart;
      RSS:=RSS+sqr(pred-obs);
      SetLength(y_prediction,lk_prediction+1);
      y_prediction[lk_prediction]:=pred;
     end;{i}
   end
   else
    begin
      for k:=1 to lk_mod do
      begin

         pom_start:=tab_zapis[k].pocz;

        for i:=pom_start to obl.tab_zapis[k].kon do
          begin
          inc(lk_prediction);
          obl_wart_modeli(obl.x[i],k);
          pred:=tab_zapis[k].wart;
          obs:=y[i];
          RSS:=RSS+sqr(pred-obs);
          SetLength(y_prediction,lk_prediction+1);
          y_prediction[lk_prediction]:=pred;
         end;{i}

      end;{k}

    end; {if work_mode else}

     RMSE_prediction:=sqrt(RSS/lk_prediction);
     MSE_actual:=RSS/lk_prediction;
     AIC_prediction:=2*lk_param+lk_prediction*ln(RSS);
     BIC_prediction:=lk_prediction*ln(RSS)+lk_param*ln(lk_prediction);

     tab_zapis[nr].RMSE:=RMSE_prediction;
     tab_zapis[nr].AIC:=AIC_prediction;
     tab_zapis[nr].BIC:=BIC_prediction;

 except
  writeln('Error in get_prediction(',nr,')');
 end;
end;


procedure oblicz.model_independent;
var i:integer;
    pom,pom1:double;
begin
try
 dissol_efficiency:=0;
 pom:=100;{maximum release}

 {compute dissol_efficiency}

 for i:=1 to n do
  begin
    if i=1 then
      dissol_efficiency:=dissol_efficiency+y[i]*x[i]/2
    else
      dissol_efficiency:=dissol_efficiency+(y[i]+y[i-1])*(x[i]-x[i-1])/2;
  end;{i}

   dissol_efficiency:=dissol_efficiency/(x[n]*pom)*100;

   {compute MDT}
 pom:=0;
 pom1:=0;
 MDT:=0;

   for i:=1 to n do
     begin
        if i=1 then
            begin
             pom1:=y[i];
             MDT:=MDT+x[i]/2*pom1
            end{if i=1 then}
          else
           begin
            pom1:=y[i]-y[i-1];
            MDT:=MDT+(x[i]+x[i-1])/2*pom1
           end;{eles}
       pom:=pom+pom1;
     end;{i}

     MDT:=MDT/pom;


finally
end;
end;{oblicz.model_independent}

procedure oblicz.oblicz_stand_err_estim(a0,b0:double;pocz1,kon1,model,liczba_param:integer);
 var i,liczba_danych:integer;
     licznik,mianownik,wariancja_reszt,pom1,pom2:double;
 begin
  try
     licznik:=0;
     pom1:=0;
     pom2:=0;
     st_err_a:=0;
     st_err_b:=0;
     percent_st_err_a:=0;
     percent_st_err_b:=0;
     wariancja_reszt:=0;

     liczba_danych:=kon1-pocz1+1;
     mianownik:=liczba_danych-liczba_param;

    for i:=pocz1 to kon1 do
                     begin
                       obl_wart_modeli_linear(x_current[i],model);
                       licznik:=licznik+sqr(y_current[i]-tab_zapis[model].wart_lin);
                     end;

     if mianownik<>0 then
      wariancja_reszt:=licznik/mianownik;

      pom1:=reszty_x;
      pom2:=sumaXX;

     if pom1<>0 then
      begin
       st_err_a:=sqrt(wariancja_reszt/pom1);
       st_err_b:=sqrt((wariancja_reszt*pom2)/(liczba_danych*pom1));
      end;{if pom1<>0}

     if a0<>0 then
        percent_st_err_a:=abs(100*st_err_a/a0);

     if b0<>0 then
       percent_st_err_b:=abs(100*st_err_b/b0);


   {  tab_zapis[model].st_err_a:=st_err_a;
     tab_zapis[model].st_err_b:=st_err_b;

     tab_zapis[model].percent_st_err_a:=percent_st_err_a;
     tab_zapis[model].percent_st_err_b:=percent_st_err_b;}


  finally
  end;
 end;{oblicz_stand_err_estim}
procedure oblicz.obl_wart_modeli_linear(wartosc1:double;model:integer);
var i:integer;
    pom:double;
 begin
   try
        i:=model;
        tab_zapis[i].wart_lin:=tab_zapis[i].a*wartosc1+tab_zapis[i].b;

    {case i of
     0,1,2,3,4,5,6,8,10,11:tab_zapis[i].wart_lin:=tab_zapis[i].a*wartosc+tab_zapis[i].b;
     7,9:tab_zapis[i].wart_lin:=tab_zapis[i].a*(wartosc-tab_zapis[i].param[2])+tab_zapis[i].b;
    end;case}

   except
     tab_zapis[i].wart_lin:=0;
   end;
 end; {oblicz.obl_wart_modeli_linear}


procedure oblicz.obl_wart_modeli(wartosc1:double;model:integer);
var i:integer;
    pom:double;
 begin
   try
     i:=model;
     tab_zapis[i].wart:=0; {?}
    case tab_zapis[i].rzad of
     0:tab_zapis[i].wart:=tab_zapis[i].param[0]*wartosc1+tab_zapis[i].param[1];
     1:tab_zapis[i].wart:=exp(tab_zapis[i].param[0]*wartosc1+tab_zapis[i].param[1]);
     2:begin
       pom:=(tab_zapis[i].param[0]*wartosc1+tab_zapis[i].param[1]);
       if pom <> 0 then
        tab_zapis[i].wart:=1/pom;
       end;
     3:begin
       pom:=(tab_zapis[i].param[0]*(wartosc1)+tab_zapis[i].param[1]);
       if pom > 0 then
              tab_zapis[i].wart:=sqrt(1/pom);
     end;
     4:tab_zapis[i].wart:=tab_zapis[i].param[0]*exp(tab_zapis[i].param[1]*ln(wartosc1));
     5:tab_zapis[i].wart:=tab_zapis[i].param[0]*ln(wartosc1)+tab_zapis[i].param[1];
     6,7:tab_zapis[i].wart:=100*(1-exp(-exp(tab_zapis[i].param[1]*ln(wartosc1-tab_zapis[i].param[2]))/tab_zapis[i].param[0])); {spr kolejnosc wspolczynnikow?}
     8,9:begin
          if tab_zapis[i].param[1]>0 then
          begin
            pom:=tab_zapis[i].param[0]*(wartosc1-tab_zapis[i].param[2])+exp(1/3*ln(tab_zapis[i].param[1]));
            tab_zapis[i].wart:=sqr(pom)*pom;
          end;
         end;{8,9}
     10:tab_zapis[i].wart:=tab_zapis[i].param[0]*sqrt(wartosc1);
     12:tab_zapis[i].wart:=tab_zapis[i].param[0]*exp(tab_zapis[i].param[1]*ln(wartosc1-tab_zapis[i].param[2]));
     13,14:begin
     pom:=(tab_zapis[i].param[0]+wartosc1-tab_zapis[i].param[2]);
     if pom <> 0 then
          tab_zapis[i].wart:=tab_zapis[i].param[1]*(wartosc1-tab_zapis[i].param[2])/pom;
     end;
     15:begin
       pom:=exp(tab_zapis[i].param[0]*ln(wartosc1));
       tab_zapis[i].wart:=100*pom/(tab_zapis[i].param[1]+pom);
     end;{15}
    end;{case}
    
   except
     tab_zapis[i].wart:=0;
   end;
 end; {oblicz.obl_wart_modeli}

procedure oblicz.zapisz_param_modeli(model:integer);
var i:integer;
 begin
   i:=model;

 end; {oblicz.zapisz_param_modeli}

procedure oblicz.otwieranie_pliku(ind:integer);
var plik:TextFile;
    lan:String;
    i,n_m:integer;
begin
  try
   i:=0;
   xmax:=-1e10;
   ymax:=-1e10;
   xmin:=1e10;
   ymin:=1e10;
   n_m:=0;
   lag:=0;

     lan:=nazwa_pliku_in;
     sciezka_out:=ExtractFilePath(lan);

    nazwa_pliku_res:=sciezka_out+'res_orders_'+ExtractFileName(lan);
    AssignFile(plik,lan);
    Reset(plik);

      while not Eof(plik)
      do begin
           inc(n_m);
           read(plik,x[n_m]);
           readln(plik,y[n_m]);

           if x[n_m]<=0 then x[n_m]:=1e-10;

           if y[n_m]<=0 then y[n_m]:=1e-10;

           if y[n_m]>=100 then y[n_m]:=99.99999999999;

           if x[n_m]>xmax then
               xmax:=x[n_m];

           if y[n_m]>ymax then
               ymax:=y[n_m];

           if x[n_m]<xmin then
               xmin:=x[n_m];

           if y[n_m]<ymin then
               ymin:=y[n_m];

         end;{while not Eof(}

        n:=n_m;
  finally
   CloseFile(plik);
  end;

end;{otwieranie_pliku}


procedure oblicz.save_res_to_file;
 var plik:TextFile;
     i:integer;

   procedure constant_write(nr:integer);
    begin
          writeln(plik,'Start point is ',#9,x[tab_zapis[i].pocz],#9,'Point no = ',#9,tab_zapis[i].pocz);
          writeln(plik,'End point is ',#9,x[tab_zapis[i].kon],#9,'Point no = ',#9,tab_zapis[i].kon);

          writeln(plik,'a = ',tab_zapis[nr].a);
          writeln(plik,'b = ',tab_zapis[nr].b);
          writeln(plik,'r = ',tab_zapis[nr].r);

          writeln(plik,'standard error for a = ',tab_zapis[nr].st_err_a);
          writeln(plik,'standard error for b = ',tab_zapis[nr].st_err_b);
          writeln(plik,'percent standard error for a = ',tab_zapis[nr].percent_st_err_a);
          writeln(plik,'percent standard error for b = ',tab_zapis[nr].percent_st_err_b);
     end;{constant_write}

    procedure write_prediction(index:integer);
      var lk1:integer;
      begin
               get_prediction(index);

               writeln(plik);
               writeln(plik,'Fitting results');
               writeln(plik);
               writeln(plik,'time',#9,'OBS',#9,'PRED');

        for lk1:=1 to lk_prediction do
            writeln(plik,x[lk1],#9,y[lk1],#9,y_prediction[lk1]);

         writeln(plik,'RMSE = ',#9,RMSE_prediction);
         writeln(plik,'AIC = ',#9,AIC_prediction);
         writeln(plik,'BIC = ',#9,BIC_prediction);
         writeln(plik);

     end;{write_prediction}

  begin
   try
     AssignFile(plik,nazwa_pliku_res);
     Rewrite(plik);


       if loop_mode and first_loop then
        begin
           first_loop:=False;
           write(plik_raportu,'File',#9);
           for i:=work_mode to lk_mod do
            begin
              if not tab_models[i] then continue;
              if tab_zapis[i].rzad<4 then
                write(plik_raportu,'Model order is ',tab_zapis[i].rzad,#9,#9,#9,#9,#9,#9,#9,#9)
               else
                 if tab_zapis[i].rzad=4 then
                  write(plik_raportu,'Korsmeyer-Peppas model',#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9)
                else
                 if tab_zapis[i].rzad=5 then
                    write(plik_raportu,'Model is y = a*ln(x)+b',#9,#9,#9,#9,#9,#9,#9,#9)
                 else
                  if tab_zapis[i].rzad = 6 then
                    write(plik_raportu,'Weibull model lag = 0',#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9)
                 else
                  if tab_zapis[i].rzad = 7 then
                    write(plik_raportu,'Weibull model adjusted lag',#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9)
                 else
                  if tab_zapis[i].rzad = 8 then
                    write(plik_raportu,'Model is Hixson-Crowell',#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9)
                 else
                  if tab_zapis[i].rzad = 9 then
                    write(plik_raportu,'Model is Hixson-Crowell with lag',#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9)
                 else
                  if tab_zapis[i].rzad = 10 then
                      write(plik_raportu,'Model is Higuchi',#9,#9,#9,#9,#9,#9,#9,#9,#9,#9)
                 else
                  if tab_zapis[i].rzad = 11 then
                      write(plik_raportu,'Model is Baker-Lonsdale',#9,#9,#9,#9,#9,#9,#9,#9,#9,#9)
                  else
                    if tab_zapis[i].rzad=12 then
                      write(plik_raportu,'Korsmeyer-Peppas model with lag time',#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9)
                  else
                    if tab_zapis[i].rzad=13 then
                      write(plik_raportu,'Michaelis-Menten model',#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9)
                  else
                    if tab_zapis[i].rzad=14 then
                      write(plik_raportu,'Michaelis-Menten model with lag time',#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9)
                  else
                    if tab_zapis[i].rzad=15 then
                      write(plik_raportu,'Hill model',#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9,#9);


                  write(plik_raportu,#9,#9,#9,#9,#9,#9,#9,#9);

            end;{i}

                 write(plik_raportu,#9,'DE',#9);
                 write(plik_raportu,'MDT',#9);

                 writeln(plik_raportu);
            {if obl.work_mode = 1 then first_loop:=True;}
         end;{if loop mode}

          if loop_mode then
           write(plik_raportu,nazwa_pliku_res,#9);

     for i:=work_mode to lk_mod do
       begin
       if not tab_models[i] then continue;

       if work_mode = 1 then
        writeln(plik,'Approximation accuracy = ',tolerance);
        writeln(plik,'--------------------------------------------');

        if tab_zapis[i].rzad<4 then
          writeln(plik,'Model order is ',tab_zapis[i].rzad)
         else
          begin
            if tab_zapis[i].rzad = 4 then
             begin
              writeln(plik,'Korsmeyer-Peppas model');
              writeln(plik,'Model is ln(y) = a*ln(x)+b');
              writeln(plik,'Which is equal to  y=K*x^A');
              writeln(plik,'K = ', exp(tab_zapis[i].b));
              writeln(plik,'A = ', tab_zapis[i].a);

              if use_NLR then
                begin
                 writeln(plik,'NLR results');
                 writeln(plik,'A = ', tab_zapis[i].param[1]);
                 writeln(plik,'K = ',tab_zapis[i].param[0]);
                end;{if use_NLR}

              if loop_mode then
                begin
                 write(plik_raportu,'K = ',#9,exp(tab_zapis[i].b),#9);
                 write(plik_raportu,'A = ',#9,tab_zapis[i].a,#9);
                end;{if loop_mode}
             end
             else if tab_zapis[i].rzad = 5 then
              writeln(plik,'Model is y = a*ln(x)+b')
             else if tab_zapis[i].rzad = 6 then
              begin
               writeln(plik,'Model is Weibull y=100*(1-exp[-((t-lag)^A)/K]');
               writeln(plik,'K = ',exp(-tab_zapis[i].b));
               writeln(plik,'A = ',tab_zapis[i].a);
               writeln(plik,'lag = 0');

               if use_NLR then
                begin
                 writeln(plik,'NLR results');
                 writeln(plik,'K = ', tab_zapis[i].param[0]);
                 writeln(plik,'A = ',tab_zapis[i].param[1]);
                 writeln(plik,'lag = 0');
                end;{if use_NLR}


               if loop_mode then
                  begin
                   write(plik_raportu,'K = ',#9,exp(-tab_zapis[i].b),#9);
                   write(plik_raportu,'A = ',#9,tab_zapis[i].a,#9);
                   write(plik_raportu,'lag = ',#9,0,#9);
                  end;
              end

             else if tab_zapis[i].rzad = 7 then
              begin
               writeln(plik,'Model is Weibull with lag time y=100*(1-exp[-((t-lag)^A)/K]');
               writeln(plik,'K = ',exp(-tab_zapis[i].b));
               writeln(plik,'A = ',tab_zapis[i].a);
               writeln(plik,'lag = ',tab_zapis[i].param[2]);

               if use_NLR then
                begin
                 writeln(plik,'NLR results');
                 writeln(plik,'K = ', tab_zapis[i].param[0]);
                 writeln(plik,'A = ',tab_zapis[i].param[1]);
                 writeln(plik,'lag = ',tab_zapis[i].param[2]);
                end;{if use_NLR}

               if loop_mode then
                  begin
                   write(plik_raportu,'K = ',#9,exp(-tab_zapis[i].b),#9);
                   write(plik_raportu,'A = ',#9,tab_zapis[i].a,#9);
                   write(plik_raportu,'lag = ',#9,tab_zapis[i].param[2],#9);
                  end;
              end

             else if tab_zapis[i].rzad = 8 then
              begin
               writeln(plik,'Model is Hixson-Crowell y=[K*(t-lag)+C0^(1/3)]^3');
               writeln(plik,'Which is equal to y^(1/3) = a*(t-lag)+b');
               writeln(plik,'K = a =',tab_zapis[i].a);
               writeln(plik,'C0 = b^3 = ',sqr(tab_zapis[i].b)*tab_zapis[i].b);
               writeln(plik,'lag = 0');

               if use_NLR then
                begin
                 writeln(plik,'NLR results');
                 writeln(plik,'K = ', tab_zapis[i].param[0]);
                 writeln(plik,'C0 = ',tab_zapis[i].param[1]);
                 writeln(plik,'lag = 0');
                end;{if use_NLR}


                 if loop_mode then
                  begin
                   write(plik_raportu,'K = ',#9,tab_zapis[i].a,#9);
                   write(plik_raportu,'C0 = ',#9,sqr(tab_zapis[i].b)*tab_zapis[i].b,#9);
                   write(plik_raportu,'lag = ',#9,0,#9);
                  end;{if loop_mode}
              end
            else if tab_zapis[i].rzad = 9 then
              begin
               writeln(plik,'Model is Hixson-Crowell y=[K*(t-lag)+C0^(1/3)]^3');
               writeln(plik,'Which is equal to y^(1/3) = a*(t-lag)+b');
               writeln(plik,'K = a =',tab_zapis[i].a);
               writeln(plik,'C0 = b^3 = ',sqr(tab_zapis[i].b)*tab_zapis[i].b);
               writeln(plik,'lag =', tab_zapis[i].param[2]);

               if use_NLR then
                begin
                 writeln(plik,'NLR results');
                 writeln(plik,'K = ', tab_zapis[i].param[0]);
                 writeln(plik,'C0 = ',tab_zapis[i].param[1]);
                 writeln(plik,'lag = ',tab_zapis[i].param[2]);
                end;{if use_NLR}

                 if loop_mode then
                  begin
                   write(plik_raportu,'K = ',#9,tab_zapis[i].a,#9);
                   write(plik_raportu,'C0 = ',#9,sqr(tab_zapis[i].b)*tab_zapis[i].b,#9);
                   write(plik_raportu,'lag = ',#9,tab_zapis[i].param[2],#9);
                  end;{if loop_mode}
              end


              else if tab_zapis[i].rzad = 10 then
              begin
               writeln(plik,'Model is Higuchi y=K*t^(1/2)');
               writeln(plik,'Which is equal to ln(y) = 1/2*ln(t)+b');
               writeln(plik,'K = exp(b) =',exp(tab_zapis[i].b));
                 if loop_mode then
                  begin
                   write(plik_raportu,'K = ',#9,exp(tab_zapis[i].b),#9);
                  end;
              end

            else if tab_zapis[i].rzad = 11 then
              begin
               writeln(plik,'Baker-Lonsdale 3/2[1-(1-y)^2/3]-y=Kt');
                 if loop_mode then
                  begin
                   write(plik_raportu,'K = ',#9,tab_zapis[i].a,#9);
                  end;
              end

            else if tab_zapis[i].rzad = 12 then
             begin
              writeln(plik,'Korsmeyer-Peppas with lag');
              writeln(plik,'Model is ln(y) = a*ln(x-lag)+b');
              writeln(plik,'Which is equal to  y=K*(x-lag)^A');
              writeln(plik,'K = ', exp(tab_zapis[i].b));
              writeln(plik,'A = ', tab_zapis[i].a);
              writeln(plik,'lag =', tab_zapis[i].param[2]);

              if use_NLR then
                begin
                 writeln(plik,'NLR results');
                 writeln(plik,'K = ', tab_zapis[i].param[0]);
                 writeln(plik,'A = ',tab_zapis[i].param[1]);
                 writeln(plik,'lag = ',tab_zapis[i].param[2]);
                end;{if use_NLR}

              if loop_mode then
                begin
                 write(plik_raportu,'K = ',#9,exp(tab_zapis[i].b),#9);
                 write(plik_raportu,'A = ',#9,tab_zapis[i].a,#9);
                 write(plik_raportu,'lag = ',#9,tab_zapis[i].param[2],#9);
                end;{if loop_mode}
             end

            else if tab_zapis[i].rzad = 13 then
             begin
              writeln(plik,'Michaelis-Menten');
              writeln(plik,'Model is 1/y = a*1/x+b');
              writeln(plik,'Which is equal to  y=ymax*x/(Km+x)');
              writeln(plik,'Km = ', tab_zapis[i].a/tab_zapis[i].b);
              writeln(plik,'ymax = ',1/tab_zapis[i].b);

             if use_NLR then
                begin
                 writeln(plik,'NLR results');
                 writeln(plik,'Km = ', tab_zapis[i].param[0]);
                 writeln(plik,'Vmax = ',tab_zapis[i].param[1]);
                 writeln(plik,'lag = 0',tab_zapis[i].param[2]);
                end;{if use_NLR}


              if loop_mode then
                begin
                 write(plik_raportu,'Km = ',#9, tab_zapis[i].a/tab_zapis[i].b,#9);
                 write(plik_raportu,'ymax = ',#9,1/tab_zapis[i].b,#9);
                end;{if loop_mode}
             end

            else if tab_zapis[i].rzad = 14 then
             begin
              writeln(plik,'Michaelis-Menten with lag');
              writeln(plik,'Model is 1/y = a*1/(x-lag)+b');
              writeln(plik,'Which is equal to  y=ymax*(x-lag)/(Km+x-lag)');
              writeln(plik,'Km = ', tab_zapis[i].a/tab_zapis[i].b);
              writeln(plik,'ymax = ',1/tab_zapis[i].b);
              writeln(plik,'lag =', tab_zapis[i].param[2]);

               if use_NLR then
                begin
                 writeln(plik,'NLR results');
                 writeln(plik,'Km = ', tab_zapis[i].param[0]);
                 writeln(plik,'Vmax = ',tab_zapis[i].param[1]);
                 writeln(plik,'lag =',tab_zapis[i].param[2]);
                end;{if use_NLR}

              if loop_mode then
                begin
                 write(plik_raportu,'Km = ',#9, tab_zapis[i].a/tab_zapis[i].b,#9);
                 write(plik_raportu,'ymax = ',#9,1/tab_zapis[i].b,#9);
                 write(plik_raportu,'lag = ',#9,tab_zapis[i].param[2],#9);
                end;{if loop_mode}
             end

           else if tab_zapis[i].rzad = 15 then
             begin
              writeln(plik,'Hill equation');
              writeln(plik,'Model is ln(y/(1-y)) = a*ln(x)+b');
              writeln(plik,'Which is equal to  y=x^N/(K+x^N)');
              writeln(plik,'N = ', tab_zapis[i].a);
              writeln(plik,'K = ',exp(-tab_zapis[i].b));

              if use_NLR then
                begin
                 writeln(plik,'NLR results');
                 writeln(plik,'N = ', tab_zapis[i].param[0]);
                 writeln(plik,'K = ',tab_zapis[i].param[1]);
                end;{if use_NLR}

              if loop_mode then
                begin
                 write(plik_raportu,'N = ',#9, tab_zapis[i].param[0],#9);
                 write(plik_raportu,'K = ',#9,tab_zapis[i].param[1],#9);
                end;{if loop_mode}
             end;{15}

          end;

           constant_write(i);

          if work_mode=0 then
           write_prediction(i);

           if add_sep_models_files then
                   spearate_models_outputs(i);

            if loop_mode then
                  begin
                        write(plik_raportu,'a = ',#9,tab_zapis[i].a,#9);
                        write(plik_raportu,'b = ',#9,tab_zapis[i].b,#9);
                        write(plik_raportu,'r = ',#9,tab_zapis[i].r,#9);
                        write(plik_raportu,'err_a = ',#9,tab_zapis[i].st_err_a,#9);
                        write(plik_raportu,'err_b = ',#9,tab_zapis[i].st_err_b,#9);
                        write(plik_raportu,'err_a(%) = ',#9,tab_zapis[i].percent_st_err_a,#9);
                        write(plik_raportu,'err_b(%) = ',#9,tab_zapis[i].percent_st_err_b,#9);
                        write(plik_raportu,'RMSE = ',#9,tab_zapis[i].RMSE,#9);
                  end;{if loop_mode}
       end; {i}

       if loop_mode then
       begin
           write(plik_raportu,#9,dissol_efficiency,#9);
           write(plik_raportu,MDT,#9);
       end;{if loop_mode}

      if work_mode=1 then
           write_prediction(0);

     writeln(plik);
     writeln(plik,'--------------------------------------------');
     writeln(plik);
     writeln(plik,'Model independent description');
     writeln(plik,'DE = ',#9,dissol_efficiency);
     writeln(plik,'MDT = ',#9,MDT);


    if lk_prediction<>n then
      writeln(plik,'No of timepoints is different tha original! n=',#9,n,#9,'but computed = ',#9,lk_prediction)
      else
          writeln(plik,'No of timepoints = ',#9,n);

    writeln(plik,'----------------------------------------------');
    writeln(plik,'End of file');

   finally
     CloseFile(plik);
     if loop_mode then writeln(plik_raportu);
   end;
  end;{save_res_to_file;}


              //procedure oblicz.save_params(no:integer);
              procedure oblicz.save_params(var tab:array of zapis;a1,b1,lag1:double;no:integer);
              //wywolanie rozne w zaleznosci od sytuacji: normalnie jak ponizej a w proc obl_abr_new z parametremami a0,b0,lag
              begin
               try
                tab[no].a:=a1;
                tab[no].b:=b1;
                case tab[no].rzad of
                      0:begin
                        tab[no].param[0]:=a1;{stala K}
                        tab[no].param[1]:=b1;{Const}
                        end;{0}
                      1:begin
                        tab[no].param[0]:=a1;{stala K}
                        tab[no].param[1]:=b1;{Const}
                        end;{1}
                      2:begin
                        tab[no].param[0]:=a1;{stala K}
                        tab[no].param[1]:=b1;{Const}
                        end;{2}
                      3:begin
                        tab[no].param[0]:=a1;{stala K}
                        tab[no].param[1]:=b1;{Const}
                        end;{3}
                      4:begin
                        {Korsmeyer-Peppas y=K*x^A}
                        tab[no].param[0]:=exp(b1);{stala K}
                        tab[no].param[1]:=a1;{A}
                        end;{4}
                      5:begin
                        {Model is y = a*ln(x)+b}
                        tab[no].param[0]:=a1;{stala K}
                        tab[no].param[1]:=b1;{Const}
                        end;{5}
                      6:begin
                        {Model is Weibull y=100*(1-exp[-((t-lag)^A)/K}
                        tab[no].param[0]:=exp(-b1);{stala K}
                        tab[no].param[1]:=a1;{A}
                        tab[no].param[2]:=0;{lag}
                        end;{6}

                      7:begin
                        {Model is Weibull with lag time y=100*(1-exp[-((t-lag)^A)/K}
                        tab[no].param[0]:=exp(-b1);{stala K}
                        tab[no].param[1]:=a1;{A}
                        tab[no].param[2]:=lag1;
                        end;{7}
                      8:begin
                        {Model is Hixson-Crowell y=[K*(t-lag)+C0^(1/3)]^3'}
                        tab[no].param[0]:=a1;{stala K}
                        tab[no].param[1]:=sqr(b1)*b1;{C0}
                        tab[no].param[2]:=0;{lag}
                        end{8};
                       9:begin
                        {Model is Hixson-Crowell with lag time y=[K*(t-lag)+C0^(1/3)]^3'}
                        tab[no].param[0]:=a1;{stala K}
                        tab[no].param[1]:=sqr(b1)*b1;{C0}
                        tab[no].param[2]:=lag1;
                        end{9};
                       10:begin
                        {Model is Higuchi y=K*t^(1/2)}
                         tab[no].param[0]:=exp(b1);{stala K}
                         end;{10}
                       11:begin
                        {Model is Baker-Lonsdale}
                         tab[no].param[0]:=a1;{stala K}
                         end;{11}
                       12:begin
                        {Korsmeyer-Peppas with lag y=K*(x-lag)^A}
                         tab[no].param[0]:=exp(b1);{stala K}
                         tab[no].param[1]:=a1;{A}
                         tab[no].param[2]:=lag1;
                        end;{12}

                       13:begin
                        {Michaelis-Menten}
                         tab[no].param[0]:=a1/b1;{stala Km}
                         tab[no].param[1]:=1/b1;{Vmax}
                         tab[no].param[2]:=0;
                        end;{13}

                       14:begin
                        {Michaelis-Menten with lag time}
                         tab[no].param[0]:=a1/b1;{stala Km}
                         tab[no].param[1]:=1/b1;{Vmax}
                         tab[no].param[2]:=lag1;
                        end;{14}

                      15:begin
                      {Model is Hill y=x^N/(K+x^N)'}
                        tab[no].param[0]:=a1;{N}
                        tab[no].param[1]:=exp(-b1);{K}
                        tab[no].param[2]:=0;{lag}
                        end{15};

                    end;
                  except
                   writeln('Error in save_params');
                  end;
              end;{save params}

              procedure oblicz.copy_piecewise_to_original;
               var i:integer;
               begin
                 for i:=1 to lk_mod do
                   begin
                     tab_zapis[i]:=tab_zapis_piecewise[i];
                   end;{i}
               end;

              procedure oblicz.save_sol(var tab: array of zapis;no:integer);
              begin
                if work_mode=0 then
                  tab[no].rzad:=no
                else
                 tab[no].rzad:=wsk_best;
                 tab[no].a:=a;
                 tab[no].b:=b;
                 tab[no].r:=r;
                 tab[no].pocz:=start;
                 tab[no].kon:=stop;

                 tab[no].st_err_a:=st_err_a;
                 tab[no].st_err_b:=st_err_b;

                 tab[no].percent_st_err_a:=percent_st_err_a;
                 tab[no].percent_st_err_b:=percent_st_err_b;


                 save_params(tab,tab[no].a,tab[no].b,lag,no);
               end;{save_sol(no:integer);}


                procedure oblicz.oblicz_abr(var a0,b0,r0:double;j,pocz1,kon1,model:integer);
                begin
                    {oblicza r kwadrat}
                   if ((j*sumaXX-sumaX*sumaX)*(j*sumaYY-sumaY*sumaY))<=0 then
                     begin
                      a:=0;
                      b:=0;
                      r:=0;
                      exit;
                     end;

                   a0:=(j*sumaXY-sumaX*sumaY)/(j*sumaXX-sumaX*sumaX);
                   b0:=(sumaY-a0*sumaX)/j;
                   r0:=sqr((j*sumaXY-sumaX*sumaY)/sqrt((j*sumaXX-sumaX*sumaX)*(j*sumaYY-sumaY*sumaY)));

                   save_params(tab_zapis,a0,b0,lag,model);


                   if licz_bledy_stand then
                    oblicz_stand_err_estim(a0,b0,pocz1,kon1,model,liczba_parametrow);
                end;


                procedure oblicz.oblicz_abr_Higuchi(var a0,b0,r0:double;j,pocz1,kon1:integer);
                var i2:integer;
                    pom_b,licznik,mianownik:double;
                begin
                    mianownik:=0;
                    licznik:=0;
                    {oblicza r kwadrat}
                   if ((j*sumaXX-sumaX*sumaX)*(j*sumaYY-sumaY*sumaY))<=0 then
                     begin
                      a:=0;
                      b:=0;
                      r:=0;
                      exit;
                     end;

                   a0:=0.5;
                   //(j*sumaXY-sumaX*sumaY)/(j*sumaXX-sumaX*sumaX);
                   b0:=(sumaY-a0*sumaX)/j;
                   r0:=0;
                   pom_b:=exp(b0);

                   save_params(tab_zapis,a0,b0,lag,10);

                   for i2:=pocz1 to kon1 do
                     begin
                       licznik:=licznik+sqr(y[i2]-(pom_b*sqrt(x[i2])))/j;
                       mianownik:=mianownik+sqr(y[i2]-srednia_y)/j;
                     end;
                     //r0 -uogolniony wg Iwasiewicz Paszek <Statystyka>
                      r0:=1-licznik/mianownik;
                   //sqr(a0*sqrt((j*sumaXX-sumaX*sumaX)/(j*sumaYY-sumaY*sumaY)));
                   //sqr((j*sumaXY-sumaX*sumaY)/sqrt((j*sumaXX-sumaX*sumaX)*(j*sumaYY-sumaY*sumaY)));
                if licz_bledy_stand then
                   oblicz_stand_err_estim(a0,b0,pocz1,kon1,10,liczba_parametrow);
                end;

               procedure oblicz.oblicz_abr_new(var a0,b0,r0:double;j,pocz1,kon1,model:integer);
                var i2:integer;
                    pom_b,licznik,mianownik:double;
                begin
                   try
                    mianownik:=0;
                    licznik:=0;
                    {oblicza r kwadrat}

                    if tab_set_param[0] then
                     a0:=set_a
                    else
                     a0:=(j*sumaXY-sumaX*sumaY)/(j*sumaXX-sumaX*sumaX);

                    if tab_set_param[1] then
                     begin
                      b0:=set_b;
                       if tab_set_param[0] then
                          a0:=set_a
                       else
                          begin
                          //a0:=(sumaY-j*b0)/sumaX; {tutaj chyba uwzglednic b?}
                            pom_b:=(sumaY-a0*sumaX)/j;
                            a0:=a0+pom_b-b0;
                          end;
                     end{if tab_set_param[1]}
                    else
                      b0:=(sumaY-a0*sumaX)/j;

                     r0:=0;

                    save_params(tab_zapis,a0,b0,lag,model);

                   for i2:=pocz1 to kon1 do
                     begin
                       obl_wart_modeli(x[i2],model);
                       licznik:=licznik+sqr(y[i2]-tab_zapis[model].wart)/j;
                       mianownik:=mianownik+sqr(y[i2]-srednia_y)/j;
                     end;
                     //r0 -uogolniony wg Iwasiewicz Paszek <Statystyka>
                      r0:=1-licznik/mianownik;

                    if licz_bledy_stand then
                      oblicz_stand_err_estim(a0,b0,pocz1,kon1,model,liczba_parametrow);
                    except
                      a:=0;
                      b:=0;
                      r:=0;
                    end;{try ... except}
                end;{oblicz_abr_new}

                procedure oblicz.sumuj(start,koniec,rzad:integer);
                  var i,lk_srednia:integer;
                      pom_x,pom_y:double;
                   begin
                              sumaX:=0;
                              sumaY:=0;
                              sumaXY:=0;
                              sumaXX:=0;
                              sumaYY:=0;
                              srednia_x:=0;
                              srednia_y:=0;
                              lk_srednia:=koniec-start+1;
                              
                           for i:=start to koniec do
                             begin
                              y_current[i]:=0;
                              x_current[i]:=0;
                              srednia_x:=srednia_x+x[i]/lk_srednia;
                              srednia_y:=srednia_y+y[i]/lk_srednia;
                             end;{i}

                     case rzad of
                        0:begin
                           for i:=start to koniec do
                             begin
                              x_current[i]:=x[i];
                              y_current[i]:=y[i];
                              sumaX:=sumaX+x[i];
                              sumaY:=sumaY+y[i];
                              sumaXY:=sumaXY+x[i]*y[i];
                              sumaXX:=sumaXX+x[i]*x[i];
                              sumaYY:=sumaYY+y[i]*y[i];
                             end;{i}
                           end;
                        1:begin
                           for i:=start to koniec do
                             begin
                              x_current[i]:=x[i];
                              y_current[i]:=ln(y[i]);
                              sumaX:=sumaX+x[i];
                              sumaY:=sumaY+ln(y[i]);
                              sumaXY:=sumaXY+x[i]*ln(y[i]);
                              sumaXX:=sumaXX+x[i]*x[i];
                              sumaYY:=sumaYY+ln(y[i])*ln(y[i]);
                             end;{i}
                           end;
                         2:begin
                           for i:=start to koniec do
                             begin
                              x_current[i]:=x[i];
                              y_current[i]:=1/y[i];
                              sumaX:=sumaX+x[i];
                              sumaY:=sumaY+1/y[i];
                              sumaXY:=sumaXY+x[i]*1/y[i];
                              sumaXX:=sumaXX+x[i]*x[i];
                              sumaYY:=sumaYY+1/y[i]*1/y[i];
                             end;{i}
                           end;
                        3:begin
                           for i:=start to koniec do
                             begin
                              x_current[i]:=x[i];
                              y_current[i]:=1/sqr(y[i]);
                              sumaX:=sumaX+x[i];
                              sumaY:=sumaY+1/sqr(y[i]);
                              sumaXY:=sumaXY+x[i]*1/sqr(y[i]);
                              sumaXX:=sumaXX+x[i]*x[i];
                              sumaYY:=sumaYY+1/sqr(y[i])*1/sqr(y[i]);
                             end;{i}
                           end;
                        4:begin
                           for i:=start to koniec do
                             begin
                              x_current[i]:=ln(x[i]);
                              y_current[i]:=ln(y[i]);
                              sumaX:=sumaX+ln(x[i]);
                              sumaY:=sumaY+ln(y[i]);
                              sumaXY:=sumaXY+ln(x[i])*ln(y[i]);
                              sumaXX:=sumaXX+ln(x[i])*ln(x[i]);
                              sumaYY:=sumaYY+ln(y[i])*ln(y[i]);
                             end;{i}
                           end;
                        5:begin
                           for i:=start to koniec do
                             begin
                              x_current[i]:=ln(x[i]);
                              y_current[i]:=y[i];
                              sumaX:=sumaX+ln(x[i]);
                              sumaY:=sumaY+y[i];
                              sumaXY:=sumaXY+ln(x[i])*y[i];
                              sumaXX:=sumaXX+ln(x[i])*ln(x[i]);
                              sumaYY:=sumaYY+y[i]*y[i];
                             end;{i}
                           end;
                        6,7:begin
                         {Weibull}
                           for i:=start to koniec do
                             begin
                              x_current[i]:=ln(x[i]-lag);
                              y_current[i]:=ln(-ln(1-y[i]/100));
                              pom_x:=ln(x[i]-lag);
                              pom_y:=ln(-ln(1-y[i]/100));
                              sumaX:=sumaX+pom_x;
                              sumaY:=sumaY+pom_y;
                              sumaXY:=sumaXY+pom_x*pom_y;
                              sumaXX:=sumaXX+sqr(pom_x);
                              sumaYY:=sumaYY+sqr(pom_y);
                             end;{i}
                           end;

                        8,9:begin
                         {Hixson-Crowell cubic law}
                           for i:=start to koniec do
                             begin
                              x_current[i]:=x[i]-lag;
                              y_current[i]:=exp(1/3*ln(y[i]));
                              pom_x:=(x[i]-lag);
                              pom_y:=exp(1/3*ln(y[i]));
                              sumaX:=sumaX+pom_x;
                              sumaY:=sumaY+pom_y;
                              sumaXY:=sumaXY+pom_x*pom_y;
                              sumaXX:=sumaXX+sqr(pom_x);
                              sumaYY:=sumaYY+sqr(pom_y);
                             end;{i}
                           end;

                        10:begin
                         {Higuchi}
                           for i:=start to koniec do
                             begin
                              x_current[i]:=ln(x[i]);
                              y_current[i]:=ln(y[i]);
                              pom_x:=ln(x[i]);
                              pom_y:=ln(y[i]);
                              sumaX:=sumaX+pom_x;
                              sumaY:=sumaY+pom_y;
                              sumaXY:=sumaXY+pom_x*pom_y;
                              sumaXX:=sumaXX+sqr(pom_x);
                              sumaYY:=sumaYY+sqr(pom_y);
                             end;{i}
                           end;
                         11:begin
                         {Baker-Lonsdale}
                           for i:=start to koniec do
                             begin
                              pom_x:=x[i];
                              pom_y:=3/2*(1-exp(2/3*ln(1-y[i]/100)))-y[i]/100;
                              x_current[i]:=pom_x;
                              y_current[i]:=pom_y;
                              sumaX:=sumaX+pom_x;
                              sumaY:=sumaY+pom_y;
                              sumaXY:=sumaXY+pom_x*pom_y;
                              sumaXX:=sumaXX+sqr(pom_x);
                              sumaYY:=sumaYY+sqr(pom_y);
                             end;{i}

                           end;

                          12:begin
                             {Korsmeyer-Peppas with lag}
                           for i:=start to koniec do
                             begin
                              x_current[i]:=ln(x[i]-lag);
                              y_current[i]:=ln(y[i]);
                              sumaX:=sumaX+ln(x[i]-lag);
                              sumaY:=sumaY+ln(y[i]);
                              sumaXY:=sumaXY+ln(x[i]-lag)*ln(y[i]);
                              sumaXX:=sumaXX+ln(x[i]-lag)*ln(x[i]-lag);
                              sumaYY:=sumaYY+ln(y[i])*ln(y[i]);
                             end;{i}
                           end;

                         13:begin
                         {Michaelis-Menten}
                           for i:=start to koniec do
                             begin
                              pom_x:=1/x[i];
                              pom_y:=1/y[i];
                              x_current[i]:=pom_x;
                              y_current[i]:=pom_y;
                              sumaX:=sumaX+pom_x;
                              sumaY:=sumaY+pom_y;
                              sumaXY:=sumaXY+pom_x*pom_y;
                              sumaXX:=sumaXX+sqr(pom_x);
                              sumaYY:=sumaYY+sqr(pom_y);
                             end;{i}

                           end;

                       14:begin
                         {Michaelis-Menten with lag}
                           for i:=start to koniec do
                             begin
                              pom_x:=1/(x[i]-lag);
                              pom_y:=1/y[i];
                              x_current[i]:=pom_x;
                              y_current[i]:=pom_y;
                              sumaX:=sumaX+pom_x;
                              sumaY:=sumaY+pom_y;
                              sumaXY:=sumaXY+pom_x*pom_y;
                              sumaXX:=sumaXX+sqr(pom_x);
                              sumaYY:=sumaYY+sqr(pom_y);
                             end;{i}

                           end;

                         15:begin
                         {Hill}
                           for i:=start to koniec do
                             begin
                              pom_x:=ln(x[i]);
                              pom_y:=ln((y[i]/100)/(1-(y[i]/100)));
                              x_current[i]:=pom_x;
                              y_current[i]:=pom_y;
                              sumaX:=sumaX+pom_x;
                              sumaY:=sumaY+pom_y;
                              sumaXY:=sumaXY+pom_x*pom_y;
                              sumaXX:=sumaXX+sqr(pom_x);
                              sumaYY:=sumaYY+sqr(pom_y);
                             end;{i}

                           end;


                       end;{case}

                       reszty_x:=0;

                       srednia_x_current:=sumaX/lk_srednia;
                       srednia_y_current:=sumaY/lk_srednia;

                       for i:=start to koniec do
                         reszty_x:=reszty_x+sqr(x_current[i]-srednia_x_current);

                    end;


      procedure oblicz.licz_model_lag(nr:integer);
       var t:integer;
           pom_r,a_best,b_best:double;
           begin
           liczba_parametrow:=3;

           if err_type in [0,1] then
                      pom_r:=0
             else pom_r:=1e10;

           lag:=0;
           lag_best:=0;

           a_best:=0;
           b_best:=0;
           
                 if x[1]>0 then
                    begin

                    for t:=0 to (lk_test_weibull-1) do
                     begin
                      lag:=t*x[1]/lk_test_weibull;
                      sumuj(start,stop,nr);
                      if new_abr then oblicz_abr_new(a,b,r,(stop-start+1),start,stop,nr)
                      else
                        oblicz_abr(a,b,r,(stop-start+1),start,stop,nr);

                     if t=0 then
                         save_sol(tab_zapis,nr);

                      {if r>r_best then}
                      if is_better_model(nr,r_best) then
                        begin
                         lag_best:=lag;
                         a_best:=a;
                         b_best:=b;
                         {r_best:=r;}//RMSE - conflict
                         wsk_best:=nr;{ktory rzad jest najlepszy}
                         save_sol(tab_zapis,nr);
                        end;{if r>r}

                      {if r>pom_r then}
                      if is_better_model(nr,pom_r) then
                       begin
                        {pom_r:=r;}//RMSE - conflict
                        a_best:=a;
                        b_best:=b;
                        lag_best:=lag;
                        save_sol(tab_zapis,nr);
                       end;{if r>pom_r}

                     end;{t}

                     a:=a_best;
                     b:=b_best;
                     {r:=pom_r;}//RMSE - conflict
                     //if r<r_best then r:=r_best;
                     lag:=lag_best;

                     //save_params(a,b,lag,nr);
                     save_sol(tab_zapis,nr);
                     sumuj(start,stop,nr);
                     oblicz_stand_err_estim(a,b,start,stop,nr,liczba_parametrow);
                     save_sol(tab_zapis,nr);

                    end;{if x[1]>0}

                 if use_NLR then
                           testsimp(nr);

            liczba_parametrow:=2;

       end;{licz_model_lag}


       procedure oblicz.startuj;
       var lk:integer;

        procedure licz_zloz_modele;
        var i,t:integer;
            kontynuuj,dopasowanie_ok:Boolean;

          begin
           if err_type in [0,1] then
                          r_best_hist:=0
              else
                  r_best_hist:=1e10;

          while lk<=n do
              begin
              dopasowanie_ok:=False;
              if err_type in[0,1] then
                                 r_best:=0
                else r_best:=1e10;

                 liczba_parametrow:=2;
                 for t:=0 to ile_modeli do
                   begin
                       kontynuuj:=False;
                       case t of
                         7,9,12,14:kontynuuj:=True;
                        end;

                    if kontynuuj then continue;

                    if not tab_models[t] then continue;

                    current_model:=t;
                    sumuj(start,stop,t);

                    if t=10 then
                       oblicz_abr_Higuchi(a,b,r,(stop-start+1),start,stop)
                     else
                     begin
                     if new_abr then oblicz_abr_new(a,b,r,(stop-start+1),start,stop,t)
                        else
                          oblicz_abr(a,b,r,(stop-start+1),start,stop,t);
                     end;{if t=10}

                        if use_NLR then
                                     testsimp(t);

                      {if r>r_best then}
                      if is_better_model(t,r_best) then
                        begin
                         {r_best:=r;}//RMSE - conflict
                         wsk_best:=t;{ktory rzad jest najlepszy}
                        end;{if r>r}
                   end;{t}

                 {test lag time for all applicable models}
               for i:=0 to ile_modeli do
               begin
                kontynuuj:=True;
                case i of
                7,9,12,14:kontynuuj:=False;
                end;

                if kontynuuj then continue;

               if tab_models[i] then
                begin
                 if x[1]>0 then
                begin
                 for t:=0 to (lk_test_weibull-1) do
                   begin
                     lag:=t*x[1]/lk_test_weibull;
                     sumuj(start,stop,i);

                     if new_abr then oblicz_abr_new(a,b,r,(stop-start+1),start,stop,i)
                        else
                         oblicz_abr(a,b,r,(stop-start+1),start,stop,i);

                     {if t=0 then
                        save_sol(lk_mod);
                     parametry dla Weibull 0}

                       if use_NLR then
                                     testsimp(i);

                   {if r>r_best then}
                   if is_better_model(i,r_best) then
                        begin
                         liczba_parametrow:=3;
                         lag_best:=lag;
                         {r_best:=r;}//RMSE - conflict
                         wsk_best:=i;{ktory rzad jest najlepszy}
                        end;{if r>r}
                     {czy tu tez zrobic pom_r jak w simple models?}
                   end;{t}
                   lag:=lag_best;
                   //save_params(i);
                   //save_params(tab_zapis[lk_mod].a,tab_zapis[lk_mod].b,lag_best,wsk_best);
                  end;{if x[0]>0}
                 end;{if tab_models[7] = Weibull}
                end;{i}

                case err_type of
                  0,1:begin
                        if (r_best>=(tolerance*r_best_hist)) then
                          dopasowanie_ok:=True
                         else dopasowanie_ok:=False;
                         if r_best>r_best_hist then
                                                    r_best_hist:=r_best;

                      end;{0,1}
                  2,3,4: begin
                          if (r_best<=(tolerance*r_best_hist)) then
                            dopasowanie_ok:=True
                          else dopasowanie_ok:=False;

                              if r_best<r_best_hist then
                                                    r_best_hist:=r_best;

                         end;{2,3,4}
                end;{case}

                 if dopasowanie_ok {and (lk>0)} then
                   begin
                       {if (r_best>(r_best_hist)) then
                                                    r_best_hist:=r_best;}
                            {zapisywanie najlepszego rozwiazania i punktu zakonczenia}
                              sumuj(start,stop,wsk_best);

                             if wsk_best=10 then oblicz_abr_Higuchi(a,b,r,(stop-start+1),start,stop)
                             else
                              begin
                               if new_abr then oblicz_abr_new(a,b,r,(stop-start+1),start,stop,wsk_best)
                               else
                                oblicz_abr(a,b,r,(stop-start+1),start,stop,wsk_best);
                              end;

                              if use_NLR then
                                     testsimp(wsk_best);

                              save_sol(tab_zapis,lk_mod);
                              oblicz_stand_err_estim(a,b,start,stop,wsk_best,liczba_parametrow);
                              save_sol(tab_zapis_piecewise,lk_mod);

                   end{if r_best>0.95...}
                  else if not dopasowanie_ok then{(r_best<(tolerance*r_best_hist))}  //RMSE - conflict tutaj znow jest kwestia znaku mniejsze/wieksze
                    begin
                      if ((n-stop)>2) then
                         begin
                           start:=stop;
                           stop:=stop+1;
                           inc(lk_mod);
                           if err_type in [0,1] then
                                                    r_best_hist:=0
                                else
                                    r_best_hist:=1e10;
                         end
                          else
                           begin
                            if wsk_best=10 then oblicz_abr_Higuchi(a,b,r,(stop-start+1),start,stop)
                             else
                              begin
                               if new_abr then oblicz_abr_new(a,b,r,(stop-start+1),start,stop,wsk_best)
                               else
                                oblicz_abr(a,b,r,(stop-start+1),start,stop,wsk_best);
                              end;

                              if use_NLR then
                                     testsimp(wsk_best);

                              save_sol(tab_zapis,lk_mod);
                              oblicz_stand_err_estim(a,b,start,stop,wsk_best,liczba_parametrow);
                              save_sol(tab_zapis_piecewise,lk_mod);

                           end;
                    end;

                stop:=stop+1;
                lk:=stop;
              end; {while}

             copy_piecewise_to_original;
             liczba_parametrow:=2;
           end; {licz_zloz_modele}

       procedure licz_prost_modele;
        var i,t:integer;
            pom_r:double;

          begin

              stop:=n;
              if err_type in [0,1] then
                                     r_best:=0
              else
                r_best:=1e10;

              pom_r:=0;
              lk_mod:=ile_modeli;

                 for t:=0 to ile_modeli do
                   begin
                    if not tab_models[t] then continue;
                    
                    current_model:=t;
                    
                    sumuj(start,stop,t);

                    if t=10 then
                       oblicz_abr_Higuchi(a,b,r,(stop-start+1),start,stop)
                     else
                      begin
                       if new_abr then oblicz_abr_new(a,b,r,(stop-start+1),start,stop,t)
                        else
                         oblicz_abr(a,b,r,(stop-start+1),start,stop,t);
                      end;{if t=10 then ... else}

                      save_sol(tab_zapis,t);

                      if use_NLR then
                                     testsimp(t);

                      {if r>r_best then}
                       if is_better_model(t,r_best) then
                        begin
                         {r_best:=r;}
                         wsk_best:=t;{ktory rzad jest najlepszy}
                        end;{if r>r}
                   end;{t}

                   for i:=0 to ile_modeli do
                      case i of
                       7,9,12,14:begin
                              if tab_models[i] then
                                    licz_model_lag(i);
                        end;{7,9,12,14}
                      end;
           end; {licz_prost_modele}


          begin

             liczba_parametrow:=2;
             {lk_test_weibull:=1000;}
             if err_type in [0,1] then
                          r_best_hist:=0
              else
                  r_best_hist:=1e10;

             lk_mod:=1;
             start:=1;
             stop:=3;

             lk:=0;

             model_independent;

             if work_mode=0 then
                 licz_prost_modele
              else licz_zloz_modele;


     end;

 function oblicz.wartosc(w:String):double;
 var kod:integer;
     bufor:double;
  begin
    wartosc:=0;
    val(w,bufor,kod);
      if kod=0 then
                wartosc:=bufor
     else wartosc:=-999;
  end;

function Func(X_optim : PVector) : Float;
var j:integer;
begin

for j:=1 to obl.liczba_parametrow do
  obl.tab_zapis[obl.current_model_NLR].param[j-1]:=X_optim^[j];

  obl.get_prediction(obl.current_model_NLR);
  Func := obl.MSE_actual;
end;



procedure oblicz.testsimp(indeks_modelu:integer);


const

  MaxIter = 1000000;    { Max number of iterations }
  Tol     = 1.0E-10;  { Required precision }


var
  X_optim    : PVector;  { Variables: X^[1] = X, X^[2] = Y }
  Fmin : Float;    { Function value at minimum }
  I,k,NVar,end_loop : Integer;  { Loop variable }
  buf_param :array [0..10] of double;
  pom_r_best:double;

  begin
      if indeks_modelu in [0,1,2,3,5,10,11] then exit;

       Nvar:=liczba_parametrow;    { Number of variables }
       DimVector(X_optim, Nvar);

       current_model_NLR:=indeks_modelu;
       pom_r_best:=r_best;
    if NLR_start_random then end_loop:=3
     else end_loop:=1;

   for k:=1 to end_loop do
   begin

       for I:=1 to NVar do
        begin
         case k of
           1:X_optim^[I] := tab_zapis[indeks_modelu].param[I-1];
           2:X_optim^[I]:=random;
           3:X_optim^[I]:=random(10);
         end;{case}
          buf_param[I]:=tab_zapis[indeks_modelu].param[I-1];
       end;{I}

     if (k=3) and (indeks_modelu = 15) then
     {specifically for Hill equation}
                  begin
                    X_optim^[1]:=xmin+(xmax-xmin)/2;
                    X_optim^[0]:=1;
                  end;{if indeks modelu= 15}


  { Save Simplex iterations in a file }
  //SaveSimplex('simplex.txt');

  { Perform minimization }

  Simplex(@Func, X_optim, 1, Nvar, MaxIter, Tol, Fmin);

  if MathErr = OptNonConv then
    begin
      Write('Non-convergence!');
     for I:=1 to NVar do
       tab_zapis[indeks_modelu].param[I-1]:=buf_param[I];
      //Halt;
    end
   else
   begin
  //Coordinates of minimum:')

   for I:=1 to NVar do
      tab_zapis[indeks_modelu].param[I-1]:=X_optim^[I];

    {checking for model accuracy and if not better then do revert to the original params}
     if not is_better_model(indeks_modelu,pom_r_best) then
      begin
      for I:=1 to NVar do
       tab_zapis[indeks_modelu].param[I-1]:=buf_param[I];
      end;

   end;{if MathErr}


   end;{k}
  end;{prcedure}

end.
